//
// evalconv.hpp
//
// conversion functions between little/big endian for all structures
// that are needed to manage the system commands, parameters and events
// the file is needed for the dummy evaluation
//
// created: 09.03.98
//
// last change: 08.10.98
//
// RCS version control information:
//     $Revision: 1.9 $$State: Exp $$Date: 1998/10/08 09:46:22 $
//


#ifndef _EVALCONV_HPP_
#define _EVALCONV_HPP_

#include "structs.hpp"


inline INT32 gi_Convert (INT32 data)
{
    return ((data << 24) & 0xFF000000) +
           ((data <<  8) & 0x00FF0000) +
           ((data >>  8) & 0x0000FF00) +
           ((data >> 24) & 0x000000FF);
}


//**************************************************************************
// macro for declaring a conversion function for a certain type
//**************************************************************************

#define DeclareConvert(type)		\
void Convert (type *s, EBool convert);


//**************************************************************************
// these are the declarations for all structures that are needed by
// the current dummy evaluation
//**************************************************************************

DeclareConvert (SModuleBase);
DeclareConvert (SEvent);
DeclareConvert (SNetEvent);
DeclareConvert (SNetCrashEvent);
DeclareConvert (SNetMessageEvent);
DeclareConvert (SApplEvent);
DeclareConvert (SApplNetEvent);
DeclareConvert (SApplGpsEvent);
DeclareConvert (SApplClockEvent);
DeclareConvert (SApplPreloadEvent);
DeclareConvert (SApplTimeEvent);
DeclareConvert (SApplRateEvent);
DeclareConvert (SApplCrashEvent);
DeclareConvert (SApplSendMsgEvent);
DeclareConvert (SApplRecvMsgEvent);
DeclareConvert (SApplDelayEvent);
DeclareConvert (SApplDelayEstimationEvent);
DeclareConvert (SParameter);
DeclareConvert (SNetworkParameter);
DeclareConvert (SNetDistributionP2P);
DeclareConvert (SNetDistribution);
DeclareConvert (SApplDistribution);
DeclareConvert (SApplWobbleDrift);
DeclareConvert (SSingleNetworkParameter);
DeclareConvert (SNetworkData);
DeclareConvert (SSingleParameter);
DeclareConvert (STimeParameter);
DeclareConvert (STransmissionData);
DeclareConvert (SRateData);
DeclareConvert (SEventReport);
DeclareConvert (SCommand);
DeclareConvert (SGpsConnectCommand);
DeclareConvert (SApplCommand);
DeclareConvert (SNetworkCreateCommand);
DeclareConvert (SNetworkCommand);
DeclareConvert (SNetworkConnectCommand);
DeclareConvert (SReply);
DeclareConvert (SBooleanReply);
DeclareConvert (SDoubleReply);

#endif

