//
// evalglob.hpp
//
// structures needed for the (dummy) evaluation
//
// created: 08.04.97
//
// last change: 05.02.99
//
// RCS version control information:
//     $Revision: 1.4 $$State: Exp $$Date: 1999/02/05 15:36:52 $
//


#ifndef _EVALGLOB_HPP_
#define _EVALGLOB_HPP_

#include "structs.hpp"


//**************************************************************************
// necessary globals
//**************************************************************************

extern INT32 supsid[];
// supervisor socket IDs (last: controller)
// needed for SelectSocket()

extern INT32 round;
// current round (set by PrintEvent())

extern EBool g_byteOrderReversed;
// byte order of communication peer is different from own


//**************************************************************************
// necessary structures
//**************************************************************************

// used for *receiving* replies to GetParameter messages; the data pointer
// points to a buffer that contains the complete parameter structure,
// 'size' denotes the size of that structure
// this structure is only used in evalsys (my own dummy evaluation), never
// in the simulation itself
struct SStructureReply : public SReply
{
    INT32 size;
    SParameter *data;

    SStructureReply (void *buf, INT32 s)
        { type = ReplyStructure; data = (SParameter *)buf; size = s; }
    virtual ~SStructureReply () { delete[] data; }
};

#endif

