//
// simerror.cpp
//
// receive strings from the datagram socket
//
// created: ??.??.98
//
// last change: 17.06.98
//
// RCS version control information:
//     $Revision: 1.4 $$State: Stable $$Date: 1998/07/03 13:12:27 $
//


#include <stdio.h>
#include <signal.h>

#include "constant.hpp"
#include "errbase.hpp"
#include "error.hpp"
#include "sockdgrm.hpp"
#include "sockinet.hpp"
#include "sockunix.hpp"

#define MAXDATA 256

static EBool g_end = False;
// is set to True by QuitProgram(), signifies that the program should end

static void QuitProgram (int sig);
// handles a CTRL-C from the keyboard (sets 'g_end' to True)


int main()
{
    char data[MAXDATA];  // data buffer
    INT32 size;  // size of one packet

    signal (SIGTERM, QuitProgram);
    signal (SIGQUIT, QuitProgram);

    CInternetAddress addr (ErrorPort);
//    CUnixAddress addr ("/tmp/SimError");
    // the socket class is the same for Internet and UNIX; only
    // the address has to change

    CDatagramServer dsock (&addr);  // create a server socket

    dsock.SetTimeout (-1);  // set the receive timeout (infinite)

    size = MAXDATA;
    while (dsock.ReceiveMessage (data, &size))  // packet was received
    {
        printf ("simulation %s\n", data);
        size = MAXDATA;
    }


    return 0;
    //exit (0);
    // note: do *not* use void main() and exit(), because obviously the
    // destructor of dsock ist not called (a UNIX socket is not removed from
    // directory /tmp); if you use return 0, then you exit the function
    // normally and the dtor is called before the function returns
}

// handles a CTRL-C from the keyboard (sets 'g_end' to True)
static void QuitProgram (int sig)
{
    if (sig != SIGQUIT)  // ignore unknown signals
    {
        Report (unknown signal);
        return;
    }

    g_end = True;
}


