//
// clock_hw.hpp
//
// declaration of the base class used for accessing the hardware clock
//
// created: 19.02.97
//
// last change: 14.08.97
//
// RCS version control information:
//     $Revision: 1.2 $$State: Exp $$Date: 1998/07/03 13:11:52 $
//


#ifndef _CLOCK_HW_HPP_
#define _CLOCK_HW_HPP_


#include "clockbas.hpp"


//**************************************************************************
// class CHardwareClock: interface to the hardware clock
//**************************************************************************

class CHardwareClock : public CClock
{
public:

    //----------------------------------------------------------------------
    // constructor, destructor
    //----------------------------------------------------------------------

    CHardwareClock (double frequency, INT32 ntiAddress);
    // assert: frequency > 0 (through the ctor of CClock)

    virtual ~CHardwareClock ();


    //----------------------------------------------------------------------
    // enable/disable single interrupt bits
    //----------------------------------------------------------------------

    virtual EBool EnableInterrupt (int area, INT32 mask1, INT32 mask2);
    // calls the global function for enabling UTCSU interrupts; adds the
    // if_num of the clock synchronization

    virtual EBool DisableInterrupt (int area, INT32 mask1, INT32 mask2);
    // calls the global function for disabling UTCSU interrupts; adds the
    // if_num of the clock synchronization
};


#endif


