//
// address.hpp
//
// provides a wrapper class for the 'addr' typedef of ci.h
//
// created: 31.07.97
//
// last change: 04.08.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _ADDRESS_HPP_
#define _ADDRESS_HPP_


#include "ci.h"

#include "error.hpp"


class CAddr
{
public:
    CAddr () {}
    CAddr (const addr *address)
      { for (int i=0; i<ADDRCNT; i++) addr_[i] = (*address)[i]; }
    CAddr (const CAddr& address)
      { for (int i=0; i<ADDRCNT; i++) addr_[i] = address.addr_[i]; }

    void operator= (const CAddr& address)
      { for (int i=0; i<ADDRCNT; i++) addr_[i] = address.addr_[i]; }

    int operator== (const CAddr& address) const
      { for (int i=0; i<ADDRCNT; i++)
            if (addr_[i] != address.addr_[i]) return 0;
        return 1; }

    int operator!= (const CAddr& address) const
      { for (int i=0; i<ADDRCNT; i++)
            if (addr_[i] != address.addr_[i]) return 1;
        return 0; }

    int operator< (const CAddr& address) const
      { for (int i=0; i<ADDRCNT; i++) {
            if (addr_[i] < address.addr_[i]) return 1;
            if (addr_[i] > address.addr_[i]) return 0; }
        return 0; }

    int operator> (const CAddr& address) const
      { for (int i=0; i<ADDRCNT; i++) {
            if (addr_[i] > address.addr_[i]) return 1;
            if (addr_[i] < address.addr_[i]) return 0; }
        return 0; }

    unsigned char& operator[] (unsigned short index)
    {
        Assert (index < ADDRCNT);
        return addr_[index];
    }


private:

    addr addr_;
};


#endif


