//
// algfree.hpp
//
// declaration of the free-run "clock synchronization algorithm", which
// does not synchronize at all, but lets the clock drift
//
// created: 03.07.97
//
// last change: 03.07.97
//
// RCS version control information:
//     $Revision: 1.2 $$State: Stable $$Date: 1998/07/03 12:37:28 $
//


#ifndef _ALGFREE_HPP_
#define _ALGFREE_HPP_


#include "algbase.hpp"


//**************************************************************************
// class CFreeRun: provides the free-run algorithm
//**************************************************************************

class CFreeRun : public ACClockSyncAlgorithm
{
public:

    //----------------------------------------------------------------------
    //--- constructor, destructor
    //----------------------------------------------------------------------

    CFreeRun (CClockSync *cs);
    // assert: cs != NULL

    virtual ~CFreeRun ();  // empty


    //----------------------------------------------------------------------
    //--- compute and set the new clock interval
    //----------------------------------------------------------------------

    virtual EBool ConvergenceFunction ();
    // empty function, always returns True


    //----------------------------------------------------------------------
    //--- creation function of class CFreeRun
    //----------------------------------------------------------------------

    static ACClockSyncAlgorithm *CreateFreeRun (CClockSync *cs);
    // creates and returns a new object of type CFreeRun
};

#endif


