//
// clockcfg.hpp
//
// some useful configuration data of the clock
//
// created: 28.03.97
//
// last change: 11.03.98
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _CLOCKCFG_HPP_
#define _CLOCKCFG_HPP_


// possible clock interrupts; OR them to the base vector to obtain the
// vector for a certain interrupt
enum EClockInterrupt {
    INTA = 0x01,  // Application Interrupt
    INTT = 0x02,  // Timer Interrupt
    INTN = 0x04   // Network Interrupt
};


// the bits in UTCINTEN, UTCINTSTAT and UTCINTCLEAR that correspond to
// the interrupt types (INTA, INTN, INTT)
// note: the registers are duplicated, so there is a Reg1/2. If a register
// does not contain any interrupts of a certain type, there is no enumeration
// item for it.
enum EInterruptBits {
    INTAReg1 = 0x3FF71000,  // bits 12..29 (13-15, 19 are unused) in reg. 1
    INTNReg2 = 0x000FFF3F,  // bits 0..19 (6, 7 are unused) in reg. 2
    INTTReg1 = 0x000007F7,  // bits 0..10 (3 unused) in reg.1
    INTTReg2 = 0xFFF00000   // bits 20..31 in reg.2
};


// the GPS units of the UTCSU
enum EGpsUnit { GPU1=0, GPU2, GPU3, EGpsUnitCount };
// GPU1 must have the value 0
// note: the last item is needed for accounting purposes and has to
// stay last even if new items are added

enum ESSUnit { SSU1=0, SSU2, SSU3, SSU4, SSU5, SSU6, ESSUnitCount };
// SSU1 must have the value 0

// note: both enumeration values should correspond to the number of units
// specified in the defines in utcsu.hpp
// use the appropriate enumeration values to access the registers of a
// unit

#endif


