//
// errbase.hpp
//
// declaration of the error report base class used for processing error
// reports
// note: this implementation simply prints the message to cerr; derive
// a class and overload the NoteError() and/or ProcessMessage() function
// to obtain different behaviour
//
// created: 31.03.97
//
// last change: 01.04.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _ERRBASE_HPP_
#define _ERRBASE_HPP_


//**************************************************************************
// class CErrorHandler: prints error messages to cerr
//**************************************************************************

class CErrorHandler
{
public:

    //----------------------------------------------------------------------
    //--- destructor
    //----------------------------------------------------------------------

    virtual ~CErrorHandler();


    //----------------------------------------------------------------------
    //--- take over an error message
    //----------------------------------------------------------------------

    virtual void NoteError (char *message);
    // calls ProcessMessage() with the message


protected:

    //----------------------------------------------------------------------
    //--- internal message output
    //----------------------------------------------------------------------

    virtual void ProcessMessage (char *string);
    // print the message (followed by a newline) to cerr
};

#endif


