//
// netgen.hpp
//
// some global functions that are needed when dealing with node identifiers
// and network addresses
// note: put the functions into sim_gen.cpp
//
// created: 18.11.96
//
// last change: 25.12.96
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _NETGEN_HPP_
#define _NETGEN_HPP_

#include "ci.h"
#include "psos.h"


//**************************************************************************
// conversion nodeID <--> network address
//**************************************************************************

extern void NodeToNetwork (SINT32 nodeID, addr* networkAddress);
// computes the network address for a node with the user identifier nodeID
// assert: networkAddress != NULL
// assert: nodeID >= 0

extern void NetworkToNode (const addr* networkAddress, SINT32& nodeID);
// computes the user node ID for a network address
// assert: networkAddress != NULL


#endif

