//
// sim_glob.hpp
//
// some object lists and global functions that are only needed in pure
// simulation
//
// note: for adding new network types, see the comments to function
//       InstallNetworks() in file sim_glob.cpp
//
// created: 12.10.96
//
// last change: 27.07.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _SIM_GLOB_HPP_
#define _SIM_GLOB_HPP_


#include "classman.hpp"
#include "cloctemp.hpp"
#include "lantemp.hpp"
#include "nettemp.hpp"


//**************************************************************************
// global variables
//**************************************************************************

extern CNetworkManager networkManager;
// the network manager that returns the creation function of a certain
// network type



//**************************************************************************
// global object lists
//**************************************************************************

extern CClockList listOfClocks;
// a list of all clocks

extern CLanceList listOfLances;
// a list of all lances

extern CNetworkList listOfNetworks;
// a list of all networks



//**************************************************************************
// initialization functions
//**************************************************************************

extern void InstallNetworks();
// installs all networks known in the system
// you must call this function once immediately after startup


#endif

