//
// sockaddr.hpp
//
// declaration (and definition) of the base class used for storing
// domain specific socket addresses; define the pure virtual functions
// in the derived class to get a working address class
//
// created: 06.02.97
//
// last change: 06.02.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _SOCKADDR_HPP_
#define _SOCKADDR_HPP_


struct sockaddr;


//**************************************************************************
// class ACSocketAddress: abstract base class for domain specific socket
//      addresses
//**************************************************************************

class ACSocketAddress
{
public:

    //----------------------------------------------------------------------
    //--- constructor, destructor
    //----------------------------------------------------------------------

    ACSocketAddress() {}
    virtual ~ACSocketAddress() {}


    //----------------------------------------------------------------------
    //--- necessary functions
    //----------------------------------------------------------------------

    virtual int Size () const =0;
    // returns the size of the address structure

    virtual int Family () const =0;
    // returns the address family

    virtual sockaddr* Addr () const =0;
    // returns the address structure itself
};


#endif


