//
// sockinet.hpp
//
// declaration of the internet domain socket address
//
// created: 06.02.97
//
// last change: 23.02.98
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _SOCKINET_HPP_
#define _SOCKINET_HPP_

#include "sockaddr.hpp"


struct sockaddr_in;


//**************************************************************************
// class CInternetAddress: inet domain address
//**************************************************************************

class CInternetAddress : public ACSocketAddress
{
public:

    //----------------------------------------------------------------------
    //--- constructor, destructor
    //----------------------------------------------------------------------

    CInternetAddress ();// use this ctor for the server (listen on any port)
    CInternetAddress (int port);// use this ctor for the server (fixed port)
    CInternetAddress (char *host, int port);  // for the client
    CInternetAddress (unsigned long ipaddress, int port);  // for the client
    CInternetAddress (const CInternetAddress& inet);
    virtual ~CInternetAddress();


    //----------------------------------------------------------------------
    //--- necessary functions
    //----------------------------------------------------------------------

    virtual int Size () const;
    // returns the size of the address structure

    virtual int Family () const;
    // returns the address family

    virtual sockaddr *Addr () const;
    // returns the address structure itself


private:

    sockaddr_in *addr_;
};


#endif

