//
// sockunix.hpp
//
// declaration of the unix domain socket address
//
// created: 06.02.97
//
// last change: 09.02.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _SOCKUNIX_HPP_
#define _SOCKUNIX_HPP_

#include "sockaddr.hpp"


struct sockaddr_un;


//**************************************************************************
// class CUnixAddress: unix domain address
//**************************************************************************

class CUnixAddress : public ACSocketAddress
{
public:

    //----------------------------------------------------------------------
    //--- constructor, destructor
    //----------------------------------------------------------------------

    CUnixAddress (const char *name);
    // assert: name != NULL

    CUnixAddress (const CUnixAddress& un);
    virtual ~CUnixAddress();


    //----------------------------------------------------------------------
    //--- necessary functions
    //----------------------------------------------------------------------

    virtual int Size () const;
    // returns the size of the address structure

    virtual int Family () const;
    // returns the address family

    virtual sockaddr *Addr () const;
    // returns the address structure itself


private:

    sockaddr_un *addr_;
};


#endif

