//
// dclient.cpp
//
// a client for checking the error datagram socket
//
// created: ??.??.97
//
// last change: 17.06.98
//


#include <stdio.h>

#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/un.h>
#include <fcntl.h>  /* for open */
#include <unistd.h>  /* for read, write, close and unlink */

#include <errno.h>

#include "process.hpp"
#include "constant.hpp"
#include "error.hpp"
#include "err2eval.hpp"
#include "sockunix.hpp"

const INT32 NumberOfMessages = MaxErrorMessages;

#define HOSTNAME "escher"


int main()
{
    int i;
    INT32 qid;
    CUnixAddress *addr = new CUnixAddress ("/tmp/SimError");
    //CInternetAddress *addr = new CInternetAddress (HOSTNAME, ErrorPort);

    CErrorEval *handler = new CErrorEval ("QERR", addr);
    InstallErrorHandler (handler);

    /* send message strings */
    Report (client starts sending);

    for (i=0; i<NumberOfMessages; i++)
    {
        Report (test message);
    }

    for (i=0; i<NumberOfMessages/MaxErrorMessages; i++) handler->Flush();
    // send MaxErrorMessages messages to the evaluation

    DeinstallErrorHandler();
    delete handler;

    return 0;
}



