//
// err2eval.hpp
//
// declaration of the error report class used for storing and processing
// error reports
// note: this implementation sends the error messages to a datagram socket
//
// created: 31.03.97
//
// last change: 11.03.98
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 09:57:06 $
//


#ifndef _ERR2EVAL_HPP_
#define _ERR2EVAL_HPP_


#include "errtask.hpp"


class ACSocketAddress;
class CDatagramClient;


//**************************************************************************
// class CErrorEval: stores strings (error messages) in a queue and
//      periodically sends them to the evaluation
//**************************************************************************

class CErrorEval : public CErrorTask
{
public:

    //----------------------------------------------------------------------
    //--- constructor, destructor
    //----------------------------------------------------------------------

    CErrorEval (char qname[4], ACSocketAddress *addr);
    // create a datagram (client) socket

    ~CErrorEval ();
    // delete the socket, emergency flush the queue


protected:

    //----------------------------------------------------------------------
    //--- internal message output
    //----------------------------------------------------------------------

    virtual void ProcessMessage (char *string);
    // send the message to the evaluation

    virtual void EmergencyProcessMessage (char *string);
    // send the message to the screen (using the ProcessMessage() function
    // of CErrorTask)


private:

    CDatagramClient *socket_;  // datagram socket to the evaluation
};

#endif


