//
// bittest.cpp
//
// this is the file used to test the classes defined in the files as far
// as possible
// *) the tests were done using a debugger to verify the correct outcome
// *) all classes were compiled and debugged using Watcom 10.5 for Windows
//
// bitmask.hpp:
// test the bitmap class CBitMask
//
// created: 23.01.97
//
// last changed: 24.01.97
//



#include "..\bitmask.hpp"
#include "..\params.hpp"  // want to store enumerations in the mask


int main()
{
    //----------------------------------------------------------------------
    // variables necessary for the test of CBitMask
    //----------------------------------------------------------------------

    int result;
    INT8 map[5] = {1,2,3,4,5};


    //----------------------------------------------------------------------
    // test the ctor

    CBitMask mask(31);
    // size = 4, bitmap = {0,0,0,0}

    CBitMask mask1 (map, 5);
    // size = 5, bitmap = {1,2,3,4,5}

    CBitMask mask2 (mask1);
    // size = 5, bitmap = {1,2,3,4,5}

    // tested on 24.01.97, 10:30: all tests okay


    //----------------------------------------------------------------------
    // test Set() and Reset()

    for (int i=0; i<5; i++) map[i] = 1;
    mask1.Set (map, 4);
    // size = 4, bitmap = {1,1,1,1}

    mask1.Reset (3);
    // size = 1, bitmap = {0}

    // tested on 24.01.97, 17:55: all tests okay


    //----------------------------------------------------------------------
    // test the operator|=
    //     calls SetBit() which calls ReAllocate(), GetIndex() and
    //     GetOffset(), so these functions are tested as well

    mask |= ClockGranularity;  // ClockGranularity has the value 29
    // bitmap = {0,0,0,32}

    mask |= Sigma;  // Sigma has the value 28
    // bitmap = {0,0,0,48}

    mask |= Delta;  // Delta has the value 0
    // bitmap = {1,0,0,48}

    mask |= CrashStatus;  // CrashStatus has the value 33
    // size = 5, bitmap = {1,0,0,48,2}

    // tested on 23.01.97, 21:50: all tests okay


    //----------------------------------------------------------------------
    // test the operator&
    //     calls GetBit(), so that function is tested as well

    result = (mask & 40);  // should return 0
    result = (mask & ClockRate);  // should return 0
    result = (mask & Sigma);  // should return != 0

    // tested on 23.01.97, 21:50: all tests okay


    //----------------------------------------------------------------------
    // test the operator^=

    mask ^= DelayMeasurementCycles;  // value is 17
    // bitmap = {1,0,2,48,4}

    mask ^= Sigma;
    // bitmap = {1,0,2,32,4}

    mask ^= 40;
    // size = 6, bitmap = {1,0,2,32,4,1}

    // tested on 23.01.97, 21:50: all tests okay


    //----------------------------------------------------------------------

    
    return 0;
}



