//
// cmantest.cpp
//
// this is the file used to test the classes defined in the files as far
// as possible
// *) the tests were done using a debugger to verify the correct outcome
// *) all classes were compiled and debugged using Watcom 10.5 for Windows
//
// test the create-function manager classes in classman.hpp
//
// created: 29.07.97
//
// last changed: 31.07.97
//


#include "..\classman.hpp"


ACClockSyncAlgorithm *DummyAlgFunction (CClockSync *) { return NULL; }
ACNetwork *DummyNetworkFunction (CControllingObject *, SINT32)
{ return NULL; }


int main()
{
    //----------------------------------------------------------------------
    // test the behaviour of the class CClassManager
    //----------------------------------------------------------------------

    CClassManager *classman;


    //----------------------------------------------------------------------
    // test ctor

    classman = new CClassManager (5);
    // size_=5, createFunction_={NULL, NULL, NULL, NULL, NULL}

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test SetFunction()

    INT32 *test = new INT32(5);

    classman->SetFunction (1, test);
    // createFunction_={NULL, test, NULL, NULL, NULL}

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test GetFunction()

    INT32 *id;

    id = classman->GetFunction (0);  // return NULL
    id = classman->GetFunction (1);  // return test
    id = classman->GetFunction (2);  // return NULL
    id = classman->GetFunction (6);  // return NULL

    // tested on 31.07.97, 10:20: all tests okay


    delete classman;
    delete test;


    //----------------------------------------------------------------------
    // test the behaviour of the class CAlgorithmManager
    // correct behaviour of CClassManager is assumed
    //----------------------------------------------------------------------

    CAlgorithmManager *algman;


    //----------------------------------------------------------------------
    // test ctor

    algman = new CAlgorithmManager;
    // size_ = 3 (EAlgorithmTypeCount)

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test SetFunction()

    algman->SetFunction (FreeRun, DummyAlgFunction);
    // createFunction_={func-ptr, NULL, NULL, NULL, NULL}

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test GetFunction()

    AlgFunction algFunc;

    algFunc = algman->GetFunction (FreeRun);  // return DummyAlgFunction()

    // tested on 29.07.97, 12:50: all tests okay


    delete algman;


    //----------------------------------------------------------------------
    // test the behaviour of the class CNetworkManager
    // correct behaviour of CClassManager is assumed
    //----------------------------------------------------------------------

    CNetworkManager *netman;


    //----------------------------------------------------------------------
    // test ctor

    netman = new CNetworkManager;
    // size_ = 1 (ENetworkTypeCount)

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test SetFunction()

    netman->SetFunction (Broadcast, DummyNetworkFunction);
    // createFunction_={func-ptr, NULL, NULL, NULL, NULL}

    // tested on 29.07.97, 12:50: all tests okay


    //----------------------------------------------------------------------
    // test GetFunction()

    NetworkFunction netFunc;

    netFunc = netman->GetFunction (Broadcast);
    // return DummyNetworkFunction()

    // tested on 29.07.97, 12:50: all tests okay


    delete netman;


    //----------------------------------------------------------------------

    return 0;
}

