//
// inlines.hpp
//
// dummy implementations of some classes, necessary for debugging;
// make defines for the classes that are needed, include this file at the
// bottom of the test file
//
// classes:
// ACClockSyncAlgorithm, ACNetwork, ACProcess, CAccountant,
// CApplControlledObject, CBitmask, CBroadcastNetwork, CClassManager,
// CClock, CClockInterface, CClockInterrupt, CClockSync, CControlledObject,
// CControllingObject, CCrashingModule, CFreeRun, CFta, CFtaWithFetzer,
// CGpsInterrupt, CInterruptProcess, CLance, CNtpTime, CRandom,
// CSoftwareClock, CSupervisor, SMsg
//
// additionals:
// Need_interrupt_management, Need_templates
//
// created: 14.02.97
//
// last change: 21.09.98
//


//--------------------------------------------------------------------------
#ifdef Need_ACClockSyncAlgorithm

#include "..\algbase.hpp"

ACClockSyncAlgorithm::ACClockSyncAlgorithm (CClockSync *) {}
ACClockSyncAlgorithm::~ACClockSyncAlgorithm () {}
void ACClockSyncAlgorithm::Reset () {}
void ACClockSyncAlgorithm::Suspend () {}
EBool ACClockSyncAlgorithm::SetParameter (const SParameter&) {return False;}
EBool ACClockSyncAlgorithm::GetParameter (SParameter&) const {return False;}
EBool ACClockSyncAlgorithm::ExecuteCommand (const SCommand&) {return False;}
EBool ACClockSyncAlgorithm::StoreTime (const STimestamp&, double,
    SINT32, const CAddr&, int, EBool) { return False; }
EBool ACClockSyncAlgorithm::StoreDelay (double, double, const SRate&, SINT32,
    const CAddr&) { return False; }
EBool ACClockSyncAlgorithm::StoreRate (const SRate&, const CNtpTime&,
    const CNtpTime&, SINT32, const CAddr&, int) { return False; }
EBool ACClockSyncAlgorithm::GetLocalRate (SRate&) const { return False; }
void ACClockSyncAlgorithm::ResetLocalRate () {}
EBool ACClockSyncAlgorithm::SetAssociation (SINT32, const CAddr&, SINT32)
    { return False; }
EBool ACClockSyncAlgorithm::DeleteAssociation (SINT32, SINT32) { return False; }
void ACClockSyncAlgorithm::SetNewClockValue () {}
void ACClockSyncAlgorithm::PreloadNewClockValue (double) {}
EBool ACClockSyncAlgorithm::ComputeNewDelay (double, double, SINT32,
    const CAddr&) { return False; }
SINT32 ACClockSyncAlgorithm::GetAssociatedNetwork () const {return -1;}
EBool ACClockSyncAlgorithm::GetResynchronizationStatus () const {return False;}
void ACClockSyncAlgorithm::SetResynchronizationStatus (EBool) const {}
CClockInterface *ACClockSyncAlgorithm::GetClock () const { return NULL; }
void ACClockSyncAlgorithm::ReportEvent (SEvent *) {}
void ACClockSyncAlgorithm::ReportInterval (EBool, const STimeInterval&) {}
void ACClockSyncAlgorithm::ReportRate (EBool, const SRate&) {}
int ACClockSyncAlgorithm::ReportError (EReportType, char *, int,
    char *) { return 0; }
void ACClockSyncAlgorithm::Init () {}
void ACClockSyncAlgorithm::Dispose () {}
void ACClockSyncAlgorithm::GetOwnID (SINT32&, int&) const {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_ACNetwork

#include "..\netbase.hpp"
#include "..\sim_globs.hpp"

ACNetwork::ACNetwork (CControllingObject *ctrl, SINT32 networkID)
    : CControlledObject (ctrl) {
  networkID_ = networkID; listOfNetworks.Insert (this, networkID); }
ACNetwork::~ACNetwork () { listOfNetworks.Remove (networkID_); }
void ACNetwork::Reset () {}
void ACNetwork::Crash () {}
EBool ACNetwork::SetParameter (const SParameter&) { return False; }
EBool ACNetwork::GetParameter (SParameter&) const { return False; }
EBool ACNetwork::ExecuteCommand (const SCommand&) { return False; }
void ACNetwork::Connect (SINT32) {}
void ACNetwork::Disconnect (SINT32) {}
void ACNetwork::SendMsg (tenvx *, bufx *, INT16, int) {}
void ACNetwork::Init () {}
void ACNetwork::Dispose() {}
SINT32 ACNetwork::GetNetworkID () { return -1; }
void ACNetwork::Transmit (SMsg *) {}
void ACNetwork::Deliver (SMsg *) {}
void ACNetwork::ReportCrashChange () {}
void ACNetwork::ReportEvent (EEvent) {}
int ACNetwork::ReportError (EReportType, char *, int, char *) { return 0; }

#endif

//--------------------------------------------------------------------------
#ifdef Need_ACProcess

#include "..\process.hpp"

const unsigned long DefaultProcessID = 0;
// for processes that don't have an ID at the time of creation

ACProcess::ACProcess (unsigned long) {}
ACProcess::~ACProcess() {}
void ACProcess::Suspend() {}
void ACProcess::Activate () {}
void ACProcess::ReActivate () {}
void ACProcess::ReActivateAt (double) {}
void ACProcess::ReActivateDelay (double) {}
void ACProcess::Cancel() {}
void ACProcess::terminate() {}
EBool ACProcess::idle () const { return False; }
double ACProcess::evtime() const { return 0; }
const ACProcess* ACProcess::current() { return 0; }
double ACProcess::CurrentTime() { return 0; }
void ACProcess::SetCurrentTime (double) {}
void ACProcess::SetActiveProcess (ACProcess *) {}
void ACProcess::Hold (double) {}
void ACProcess::tm_wkafter (INT32) {}
void ACProcess::SetNodeID (unsigned long) {}
unsigned long ACProcess::GetNodeID () const { return 0; }

#endif

//--------------------------------------------------------------------------
#ifdef Need_CAccountant

#include "..\account.hpp"

CAccountant::CAccountant () {}
CAccountant::~CAccountant () {}
void CAccountant::Reset() {}
void CAccountant::SetDelay (SDelay, SINT32, addr *) {}
EBool CAccountant::GetDelay (SDelay *, SINT32, addr *) {return False;}
EBool CAccountant::DeleteKey1 (SINT32) {return False;}
EBool CAccountant::DeleteKey2 (addr *) {return False;}
void CAccountant::Init() {}
void CAccountant::Dispose() {}
void CAccountant::ResetDataEntry () {}
EBool CAccountant::GetInformation (SINT32, addr *) {return False;}
void CAccountant::SetInformation () {}
void CAccountant::SetupDataEntry (SINT32, addr *) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CApplControlledObject

#include "..\ctrled.hpp"

CApplControlledObject::CApplControlledObject (CControllingObject *ctrl) :
    CControlledObject (ctrl) {}
void CApplControlledObject::ReportEvent (EModule, EEvent) {}
void CApplControlledObject::ReportEvent (SEvent *) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CBitmask

#include "..\bitmask.hpp"

CBitMask::CBitMask (INT32) {}
CBitMask::CBitMask (void *, INT32) {}
CBitMask::CBitMask (const CBitMask&) {}
CBitMask::~CBitMask () {}
void CBitMask::Set (const void *, INT32) {}
void CBitMask::Reset (INT32) {}
int CBitMask::operator& (const INT32) const {return 0;}
CBitMask& CBitMask::operator|= (const INT32) { return *this; }
CBitMask& CBitMask::operator^= (const INT32) { return *this; }
INT32 CBitMask::GetIndex (INT32) const { return 0; }
INT32 CBitMask::GetOffset (INT32) const { return 0; }
void CBitMask::SetBit (INT32) {}
int CBitMask::GetBit (INT32) const { return 0; }
void CBitMask::Allocate (INT32) {}
void CBitMask::ReAllocate (INT32) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CBroadcastNetwork

#include "..\network.hpp"

CBroadcastNetwork::CBroadcastNetwork (CControllingObject *ctrl,
    SINT32 networkID) : ACNetwork (ctrl, networkID) {}
static ACNetwork *CBroadcastNetwork::CreateNetwork (CControllingObject *,
    SINT32) { return NULL; }
void CBroadcastNetwork::SendMsg (SMsg *) {}
void CBroadcastNetwork::Transmit (SMsg *) {}

#endif


//--------------------------------------------------------------------------
#ifdef Need_CClassManager

#include "..\classman.hpp"

CClassManager::CClassManager (INT32) {}
CClassManager::~CClassManager () {}
void CClassManager::SetFunction (INT32, INT32 *) {}
INT32 *CClassManager::GetFunction (INT32) { return NULL; }

#endif


//--------------------------------------------------------------------------
#ifdef Need_CClock

#include "..\clockbas.hpp"

CClock::CClock (double, SUtcsuRead *, SUtcsuWrite *) {}
EBool CClock::SetParameter (const SParameter&) { return False; }
EBool CClock::GetParameter (SParameter&) const { return False; }
EBool CClock::EnableInterrupt (int, INT32, INT32) { return False; }
EBool CClock::DisableInterrupt (int, INT32, INT32) { return False; }

#endif


//--------------------------------------------------------------------------
#ifdef Need_CClockInterface

#include "..\clockifc.hpp"

CClockInterface::CClockInterface (CControllingObject *ctrl, double, int)
    : CApplControlledObject (ctrl) {}
CClockInterface::~CClockInterface () {}
void CClockInterface::DisableDutyTimer (EInterruptSource) {}
CClock *CClockInterface::GetClock () { return NULL; }
EBool CClockInterface::SetParameter (const SParameter&) { return False; }
EBool CClockInterface::GetParameter (SParameter&) const { return False; }
EBool CClockInterface::ExecuteCommand (const SCommand&) { return False; }
EBool CClockInterface::SetAmortizationDuration (double) { return False; }
EBool CClockInterface::GpsConnected () { return False; }
void CClockInterface::AddGps (EGpsUnit) {}
void CClockInterface::RemoveGps (EGpsUnit) {}
double CClockInterface::GetRhoPlus() const {return 0;}
double CClockInterface::GetRhoMinus() const {return 0;}
double CClockInterface::GetGranularity() const {return 0;}
double CClockInterface::GetGranularityAcc() const {return 0;}
double CClockInterface::GetGranularityOsc() const {return 0;}
double CClockInterface::GetGranularityDT() const {return 0;}
INT32 CClockInterface::GetAccuracy() const {return 0;}
EBool CClockInterface::GetTimestamp (STimestamp&) { return False; }
void CClockInterface::SetTimestamp (const STimestamp&) {}
void CClockInterface::SetTimestamp (const SExtendedTimestamp&) {}
void CClockInterface::PreloadTimestamp (double, const STimestamp&) {}
void CClockInterface::PreloadTimestamp (double, const SExtendedTimestamp&) {}
void CClockInterface::EnableInterrupt (EInterruptSource) {}
void CClockInterface::DisableInterrupt (EInterruptSource) {}
EBool CClockInterface::InterruptPending (EInterruptSource) { return False; }
EBool CClockInterface::InterruptPending (EClockInterrupt) { return False;  }
void CClockInterface::ClearInterrupt (EInterruptSource) {}
void CClockInterface::ClearInterrupt (EClockInterrupt) {}
void CClockInterface::InterruptAt (EInterruptSource, double) {}
void CClockInterface::InterruptAfter (EInterruptSource, double) {}
double CClockInterface::InterruptAtMult (EInterruptSource, double) { return 0; }
void CClockInterface::Init () {}
void CClockInterface::Dispose() {}
void CClockInterface::isr() {}
void CClockInterface::wobble_isr() {}
void CClockInterface::PreloadAmort (double, INT32, INT32) {}
void CClockInterface::Amortize (double, INT32, INT32) {}
void CClockInterface::Reset () {}
void CClockInterface::Crash () {}
void CClockInterface::Recover () {}
void CClockInterface::ReportCrashChange () {}
void CClockInterface::InjectFaults() {}
void CClockInterface::SetFaultyDrift (double) {}
double CClockInterface::GetFaultyDrift () { return 0; }
int CClockInterface::ReportError (EReportType, char*, int, char*) {return 0;}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CClockSync

#include "..\clocksyn.hpp"

CClockSync::CClockSync (CControllingObject *ctrl, int)
    : CApplControlledObject (ctrl) {}
CClockSync::~CClockSync () {}
void CClockSync::Suspend () {}
EBool CClockSync::SetParameter (const SParameter&) { return False; }
EBool CClockSync::GetParameter (SParameter&) const { return False; }
EBool CClockSync::ExecuteCommand (const SCommand&) { return False; }
void CClockSync::SetLance (CLance *) {}
void CClockSync::SetClock (CClockInterface *) {}
void CClockSync::BroadcastTime () {}
void CClockSync::Announce (renvx*, STimeData, char*, INT16, int, INT32) {}
void CClockSync::Resynchronize () {}
void CClockSync::isr () {}
void CClockSync::Init () {}
void CClockSync::Dispose () {}
int CClockSync::ReportError (EReportType, char *, int, char *) { return 0; }
void CClockSync::ComputeDelay (renvx *, STimeData&,SReplyData&, STimeData&,
    int) {}
void CClockSync::ReplyToMessage (renvx *, STimeData&, int) {}
void CClockSync::StoreTime (renvx *, STimeData&, int, EBool) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CControlledObject

#include "..\ctrled.hpp"

CControlledObject::CControlledObject (CControllingObject *) {}
CControlledObject::~CControlledObject () {}
SINT32 CControlledObject::GetNodeID() { return 0; }
void CControlledObject::Reset() {}
EBool CControlledObject::SetParameter (const SParameter&) { return False; }
EBool CControlledObject::GetParameter (SParameter&) const { return False; }
EBool CControlledObject::ExecuteCommand (const SCommand&) { return False; }
void CControlledObject::ReportEvent (EModule, EEvent) {}
void CControlledObject::ReportEvent (SEvent *) {}
void CControlledObject::Init () {}
void CControlledObject::Dispose () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CControllingObject

#include "..\ctrling.hpp"

CControllingObject::CControllingObject (char *, ACSocketAddress *, SINT32) {}
CControllingObject::~CControllingObject () {}
void CControllingObject::Reset() {}
EBool CControllingObject::SetParameter (const SParameter&) { return False; }
EBool CControllingObject::GetParameter (SParameter&) const { return False; }
EBool CControllingObject::ExecuteCommand (const SCommand&) { return False; }
void CControllingObject::NoteEvent (SEvent *) {}
void CControllingObject::Body() {}
ACSocketAddress *CControllingObject::GetSocketAddress () { return 0; }
void CControllingObject::ReplyToMessage (double) {}
void CControllingObject::ReplyToMessage (EBool) {}
void CControllingObject::ReplyToMessage (SBase *) {}
SEvent *CControllingObject::GetEvent () { return 0; }
int CControllingObject::ReportError (EReportType, char *, int, char *) { return 0; }
void CControllingObject::EmptyQueue () {}
EBool CControllingObject::EventReportAllowed (EEvent) { return False; }
void CControllingObject::UpdateMask (CBitMask&, const SEventReport *) {}
void CControllingObject::GetBit (const CBitMask&, SEventReport *) const {}
EBool CControllingObject::InitEventTable () { return False; }
void CControllingObject::Resynchronize() {}
void CControllingObject::ProcessData (EMessageType) {}
void CControllingObject::TransmitEvent (SEvent *) {}
void CControllingObject::DoPeriodicActivities () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CCrashingModule

CCrashingModule::CCrashingModule () {}
void CCrashingModule::Reset () {}
EBool CCrashingModule::SetProbability (EBool, double) { return False; }
double CCrashingModule::GetProbability (EBool) const { return 0; }
EBool CCrashingModule::Crashed () const { return False; }
EBool CCrashingModule::ExecuteCommand (const SCommand&) { return False; }
void CCrashingModule::Crash () {}
void CCrashingModule::Recover () {}
EBool CCrashingModule::ModifyCrashStatus () { return False; }
void CCrashingModule::ReportCrashChange () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CFreeRun

#include "../algfree.hpp"

CFreeRun::CFreeRun (CClockSync *cs) : ACClockSyncAlgorithm (cs) {}
CFreeRun::~CFreeRun () {}
EBool CFreeRun::ConvergenceFunction () { return False; }
ACClockSyncAlgorithm *CFreeRun::CreateFreeRun (CClockSync *cs) { return new CFreeRun(cs); }

#endif

//--------------------------------------------------------------------------
#ifdef Need_CFta

#include "../algfta.hpp"

CFta::CFta (CClockSync *cs) : ACClockSyncAlgorithm (cs) {}
EBool CFta::ConvergenceFunction () { return False; }
EBool CFta::FTA (STimeInterval&, SINT32) { return False; }
ACClockSyncAlgorithm *CFta::CreateFta (CClockSync *cs) { return new CFta(cs); }

#endif

//--------------------------------------------------------------------------
#ifdef Need_CFtaWithFetzer

#include "../algfetz.hpp"

CFtaWithFetzer::CFtaWithFetzer (CClockSync *cs) : CFta (cs) {}
CFtaWithFetzer::~CFtaWithFetzer () {}
void CFtaWithFetzer::Suspend () {}
EBool CFtaWithFetzer::StoreTime (const STimestamp&, double, SINT32,
  const CAddr&, int, EBool) { return False; }
EBool CFtaWithFetzer::ConvergenceFunction () { return False; }
ACClockSyncAlgorithm *CFtaWithFetzer::CreateFtaWithFetzer (CClockSync *cs)
  { return new CFtaWithFetzer(cs); }
void CFtaWithFetzer::Init () {}
void CFtaWithFetzer::Dispose () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CGpsInterrupt
#define Need_CClockInterrupt
// this class needs the base class as well

#include "..\clockirq.hpp"

CGpsInterrupt::CGpsInterrupt (unsigned long nodeID, CSoftwareClock *,
    EGpsUnit) : CClockInterrupt (nodeID) {}
void CGpsInterrupt::SetTimeVector (int) {}
void CGpsInterrupt::EnableTime () {}
void CGpsInterrupt::DisableTime() {}
void CGpsInterrupt::PreExecution () {}
void CGpsInterrupt::PostExecution () {}


#endif

//--------------------------------------------------------------------------
#ifdef Need_CClockInterrupt
#define Need_CInterruptProcess
// this class needs the base class as well

#include "..\clockirq.hpp"
// the implementation is found in the header file

#endif

//--------------------------------------------------------------------------
#ifdef Need_CInterruptProcess

#include "..\intproc.hpp"

CInterruptProcess::CInterruptProcess () {}
void CInterruptProcess::SetVector (int) {}
void CInterruptProcess::Enable () {}
void CInterruptProcess::Disable () {}
EBool CInterruptProcess::Enabled () { return False; }
EBool CInterruptProcess::Active () { return False; }
void CInterruptProcess::RaiseAfter (double) {}
void CInterruptProcess::CancelInterrupt () {}
void CInterruptProcess::Body () {}
void CInterruptProcess::PreExecution () {}
void CInterruptProcess::PostExecution () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CLance

#include "..\lance.hpp"

CLance::CLance (CControllingObject *ctrl, int) : CApplControlledObject (ctrl) {}
CLance::~CLance () {}
void CLance::Reset () {}
EBool CLance::SetParameter (const SParameter&) {return False;}
EBool CLance::GetParameter (SParameter&) const {return False;}
EBool CLance::ExecuteCommand (const SCommand&) {return False;}
void CLance::Suspend() {}
void CLance::SetClockSync (CClockSync *) {}
void CLance::SetClock (CClockInterface *) {}
int CLance::GetBuffer (INT16, char **, int, int, INT32&) { return -1; }
int CLance::GetEnvelope (int, tenvx **, int, int) { return -1; }
int CLance::ReturnBuffer (char *) { return -1; }
int CLance::ReturnEnvelope (tenvx *) { return -1; }
void CLance::Send (int, tenvx *, char *, INT16, int, int) {}
void CLance::Announce (renvx *, bufx *, INT16, int) {}
int CLance::SendNow (int, tenvx *, char *, INT16, int, int) {return -1;}
void CLance::AnnounceNow (renvx *, bufx *, INT16, int) {}
void CLance::Init () {}
void CLance::Dispose () {}
void CLance::DelayMessage (int, tenvx *, char *, INT16, int, int) {}
void CLance::DelayMessage (renvx *, bufx *, INT16, int) {}
void CLance::ReportCrashChange() {}
void CLance::ReportMessageEvent (EEvent, INT32) {}
void CLance::ReportMessageEvent (EEvent, SINT32, int, INT32) {}
void CLance::isr() {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CNtpTime

#include "..\time.hpp"

CNtpTime::CNtpTime() {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CRandom

#ifdef NO_DISTRIB_LIB
#include "..\random.hpp"

CRandomStream::CRandomStream (long, long) {}
void CRandomStream::SetSeeds (long, long, long) {}
void CRandomStream::GetSeeds (long&, long&, long&) const {}
double CRandomStream::Uniform() { return 0; }
double CRandomStream::MGen() { return 0; }
long CRandomStream::MSeedGen (long) const { return 0; } 
long CRandomStream::LSeedGen (long) const { return 0; }

CUniformStream::CUniformStream (long, long, int) {}
double CUniformStream::operator() () { return 0; }
void CUniformStream::SetRange (double, double) {}

CNormalStream::CNormalStream (long, long, int) {}
double CNormalStream::operator() () { return 0; }
void CNormalStream::SetRange (double, double) {}

CExponentialStream::CExponentialStream (long, long, int) {}
double CExponentialStream::operator() () { return 0; }
void CExponentialStream::SetRange (double, double) {}

CDraw::CDraw (double, int) {}
EBool CDraw::operator() () { return False; }
void CDraw::SetParameter (double) {}

CRandom::CRandom (int) {}
EBool CRandom::CastDice (double) { return False; }
double CRandom::Random (EDistribution, double, double) { return 0; }
void CRandom::SetSeeds (EDistribution, long, long, long) {}
void CRandom::GetSeeds (EDistribution, long&, long&, long&) const {}

#else
#include "..\distrib.hpp"

EBool SRandomData::DataValid() const { return True; }

distributions::distributions (long, long) {}
void distributions::SetSeeds (long, long, long) {}
void distributions::GetSeeds (long&, long&,long&) const {}
double distributions::GetUniform () { return 0; }
double distributions::MGen () { return 0; }
long distributions::MSeedGen (long) const { return 0; }
long distributions::LSeedGen (long) const { return 0; }

CUniform::CUniform (double, double, int) {}
double CUniform::operator() () { return 0; }
void CUniform::SetRange (double, double, double) {}

C_exponential::C_exponential (double, double, double, double, int) {}
double C_exponential::operator() () { return 0; }
void C_exponential::set (double, double, double, double) {}

C_normal::C_normal (double, double, double, double, double, int) {}
double C_normal::operator() () { return 0; }
void C_normal::set (double, double, double, double, double) {}

C_gamma::C_gamma (double, double, double, double, int) {}
double C_gamma::operator() () { return 0; }
void C_gamma::set (double, double, double, double) {}

C_weibull::C_weibull (double, double, double, double, int) {}
double C_weibull::operator() () { return 0; }
void C_weibull::set (double, double, double, double) {}

C_generic::C_generic (int) {}
double C_generic::operator() () { return 0; }
void C_generic::set (double, double, double, double *, unsigned long){}

CRandom::CRandom (int) : uniform (1,1), exponential (1,1,1,1),
  normal (1,1,1,1,1), gamma (1,1,1,1), weibull (1,1,1,1), generic (1) {}
EBool CRandom::CastDice (double) { return False; }
double CRandom::RandomVar (EDistribution) { return 0; }
double CRandom::RandomVar (EDistribution, double, double, double, double, double)
  { return 0; }
double CRandom::RandomVar (SRandomData&) { return 0; }
double CRandom::RandomVar (double, double) { return 0; }
void CRandom::Set (EDistribution, double, double, double, double, double) {}
void CRandom::SetGeneric (double, double, double, double *, unsigned long) {}
void CRandom::SetSeeds (EDistribution, long, long, long) {}
void CRandom::GetSeeds (EDistribution, long&, long&, long&) const {}

#endif  // NO_DISTRIB_LIB - else

#endif

//--------------------------------------------------------------------------
#ifdef Need_CSoftwareClock

#include "..\clock_sw.hpp"

void CSoftwareClock::DumpRegisters () {}  // debugging

CSoftwareClock::CSoftwareClock (double frequency, SINT32, int)
    : CClock (frequency, NULL, NULL) {}
CSoftwareClock::~CSoftwareClock () {}
EBool CSoftwareClock::SetParameter (const SParameter&) { return False; }
EBool CSoftwareClock::GetParameter (SParameter&) const { return False; }
INT32 CSoftwareClock::GetTSGETL() { return 0; }
INT32 CSoftwareClock::GetAMORTTIMEGETL() { return 0; }
INT32 CSoftwareClock::GetSTATEPGETL() { return 0; }
INT32 CSoftwareClock::GetALPHAPGETL() { return 0; }
INT32 CSoftwareClock::GetALPHANGETL() { return 0; }
INT32 CSoftwareClock::GetUTCSTAT1() { return 0; }
INT32 CSoftwareClock::GetUTCCONF1() { return 0; }
INT32 CSoftwareClock::GetUTCCONF2() { return 0; }
void CSoftwareClock::SetMSSET(INT32) {}
void CSoftwareClock::SetNTPSET(INT32) {}
void CSoftwareClock::SetSTEPAMORT(INT32) {}
void CSoftwareClock::SetSTARTAMORT(INT32) {}
void CSoftwareClock::SetALPHAPNSET(INT32) {}
void CSoftwareClock::SetSWRESET(INT32) {}
void CSoftwareClock::SetUTCINTEN1(INT32) {}
void CSoftwareClock::SetUTCINTEN2(INT32) {}
void CSoftwareClock::SetUTCINTCLEAR1(INT32) {}
void CSoftwareClock::SetUTCINTCLEAR2(INT32) {}
void CSoftwareClock::SetSWSNAP(INT32) {}
void CSoftwareClock::SetAPPDUTYH(INT32) {}
void CSoftwareClock::SetAPPDUTYL(INT32) {}
void CSoftwareClock::SetDUTYAH (ESSUnit, INT32) {}
void CSoftwareClock::SetDUTYAL (ESSUnit, INT32) {}
void CSoftwareClock::SetDUTYBH (ESSUnit, INT32) {}
void CSoftwareClock::SetDUTYBL (ESSUnit, INT32) {}
void CSoftwareClock::CaptureTime (EGpsUnit) {}
CGpsInterrupt *CSoftwareClock::GetGpsInterrupt (EGpsUnit) { return NULL; }
EGpsUnit CSoftwareClock::GetGpsUnit() { return EGpsUnitCount; }
void CSoftwareClock::Init() {}
void CSoftwareClock::Dispose() {}
int CSoftwareClock::ReportError (EReportType, char *, int, char *) { return 0; }
void CSoftwareClock::HwSnapshot() {}
void CSoftwareClock::SwSnapshot() {}
void CSoftwareClock::SetSignal (INT8) {}
EBool CSoftwareClock::GetSignal (INT8) { return False; }
void CSoftwareClock::ClearSignal (INT8) {}
EBool CSoftwareClock::GetPolarity (INT8) { return False; }
void CSoftwareClock::Update() {}
void CSoftwareClock::UpdateNtp (INT32, const CNtpTime&) {}
void CSoftwareClock::UpdateEnvelopes (EBool, const CNtpTime&) {}
void CSoftwareClock::SetUpperLimit (EBool) {}
void CSoftwareClock::SetLowerLimit (EBool) {}
void CSoftwareClock::GetEnvelope (EBool, INT32&, INT16&) {}
void CSoftwareClock::SetEnvelope (EBool, INT32, INT16) {}
double CSoftwareClock::GetRealDelay (double) { return 0; }
void CSoftwareClock::GetClockCycles (double, CNtpTime&) {}
INT32 CSoftwareClock::GetAmortCycles (const CNtpTime&) { return 0; }
double CSoftwareClock::GetRate (INT32) { return 0; }
void CSoftwareClock::EnableInterrupt (INT8) {}
void CSoftwareClock::DisableInterrupt (INT8) {}
CClockInterrupt *CSoftwareClock::CreateInterrupt (INT8) { return NULL; }
void CSoftwareClock::RescheduleInterrupts () {}
void CSoftwareClock::ScheduleInterrupt (INT8) {}
void CSoftwareClock::ScheduleInterrupt (CClockInterrupt *) {}
void CSoftwareClock::DescheduleInterrupt (INT8) {}
double CSoftwareClock::GetCurrentClockValue() { return 0; }
INT32 CSoftwareClock::GetAccuracy() { return 0; }
void CSoftwareClock::SetOverflow (int) {}
void CSoftwareClock::ModifiedDutyTimer (EDutyTimer, const CNtpTime&) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_CSupervisor

#include "..\supervis.hpp"

CSupervisor::CSupervisor (char qname[4], ACSocketAddress *addr, SINT32 nodeID,
    int, double) : CControllingObject (qname, addr, nodeID) {}
CSupervisor::~CSupervisor () {}
void CSupervisor::Reset() {}
void CSupervisor::SuspendOperation () {}
void CSupervisor::ResumeOperation () {}
CClockInterface *CSupervisor::GetClock () {return 0;}
CClockSync *CSupervisor::GetClockSync () {return 0;}
EBool CSupervisor::SetParameter (const SParameter&) {return False;}
EBool CSupervisor::GetParameter (SParameter&) const {return False;}
EBool CSupervisor::ExecuteCommand (const SCommand&) {return False;}
void CSupervisor::NoteEvent (SEvent *) {}
int CSupervisor::ReportError (EReportType, char *, int, char *) { return 0;}
void CSupervisor::DoPeriodicActivities () {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_SMsg

#include "..\sim_gen.hpp"

void SetCurrentNodeID (SINT32) {}
void ResetCurrentNodeID () {}
extern SINT32 GetCurrentNodeID () { return 0; }

SMsg::SMsg () {}
SMsg::SMsg (bufx *, INT16, int, int) {}
SMsg::SMsg (const SMsg&) {}
SMsg::~SMsg() {}
SMsg& SMsg::operator= (const SMsg&) { return *this; }
void SMsg::SetTime (STimestamp) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_interrupt_management

#include "..\interupt.hpp"

void CallISR (CNeedInterrupt *) {}
void SetISR (int, CNeedInterrupt *, CallFunc) {}
void RemoveISR (int, CNeedInterrupt *, CallFunc) {}
void InvokeISR (int) {}

#endif

//--------------------------------------------------------------------------
#ifdef Need_templates

#include "..\clockbas.hpp"
#include "..\gpsbase.hpp"

class CClockInterface;

CClock *CClockTemplate::NewClock (double, long, int) { return NULL; }
ACGps *CGpsTemplate::NewGPS (CClockInterface *, int) { return NULL; }

CClockTemplate *clockTemplate = new CClockTemplate;
CGpsTemplate *gpsTemplate = new CGpsTemplate;

#endif



//--------------------------------------------------------------------------
#ifdef Need_

#endif

//--------------------------------------------------------------------------
#ifdef Need_

#endif



