//
// itoa.cpp
//
// provides an integer to string conversion
//
// created: ??.??.97
//
// last change: 06.03.98
//
// RCS version control information:
//     $Revision: 1.1 $$State: Exp $$Date: 1998/07/30 13:16:14 $
//


#include <stdlib.h>  // for NULL


//**************************************************************************
// convert integer to string
//**************************************************************************


#ifndef DOS_SIM
// itoa() is not ANSI, so it is only available when using Watcom (DOS)

// converts the value "value" in base "radix" to a string and writes the
// result into buffer; a pointer to that buffer is returned
// if radix < 2 or radix > 36, NULL is returned and nothing happens
char *itoa (int value, char *buffer, int radix)
{
    int index = 0;  // array index
    int mult = 1;  // for internal computations
    int res;  // result of division through mult

    if ((radix < 2) || (radix > 36)) return NULL;

    if ((radix == 10) && (value < 0))  // put a "-" as first item
    {
        buffer[index] = '-';
        index++;
    }
    if (value < 0) value = -value;  // make value a positive number

    if (value == 0)  // is not covered by the algorithm below
    {
        buffer[index] = '0';
        index++;
    }

    // first find out the highest place
    while (value/mult > 0) { mult = mult*radix; }

    // okay, value is a multiple of mult/radix
    while ((mult = mult/radix) > 0)
    {
        res = value/mult;
        if (res < 10)
        {
            buffer[index] = (char)((int)'0' + res);
        }
        else
        {
            buffer[index] = (char)((int)'a' + (res-10));
        }
        index++;
        value = value - res*mult;
    }
    buffer[index] = '\0';
    return buffer;
}

#endif


