//
// algfree.cpp
//
// implementation of the free-run "clock synchronization algorithm", which
// does not synchronize at all, but lets the clock drift
//
// created: 03.07.97
//
// last change: 03.07.97
//
// RCS version control information:
//     $Revision: 1.4 $$State: Exp $$Date: 1999/01/22 11:18:15 $
//


#include "algfree.hpp"


//**************************************************************************
// class CFreeRun: provides the free-run algorithm
//**************************************************************************

//--------------------------------------------------------------------------
//--- constructor, destructor
//--------------------------------------------------------------------------

// assert: cs != NULL (done by the ctor of ACClockSyncAlgorithm)
CFreeRun::CFreeRun (CClockSync *cs) : ACClockSyncAlgorithm (cs)
{
}

CFreeRun::~CFreeRun ()
{
}


//--------------------------------------------------------------------------
//--- compute and set the new clock interval
//--------------------------------------------------------------------------

// empty function, always returns True
EBool CFreeRun::ConvergenceFunction ()
{
    return True;
}


//--------------------------------------------------------------------------
//--- create function of class CFreeRun
//--------------------------------------------------------------------------

// creates and returns a new object of type CFreeRun
ACClockSyncAlgorithm *CFreeRun::CreateFreeRun (CClockSync *cs)
{
    return new CFreeRun (cs);
}


