//
// errbase.cpp
//
// declaration of the error report base class used for processing error
// reports
// note: this implementation simply prints the message to cerr
//
// created: 31.03.97
//
// last change: 01.04.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 10:49:31 $
//


#include <iostream.h>

#include "errbase.hpp"


//**************************************************************************
// class CErrorHandler: prints error messages to cerr
//**************************************************************************

//--------------------------------------------------------------------------
//--- destructor
//--------------------------------------------------------------------------

CErrorHandler::~CErrorHandler()
{
}


//--------------------------------------------------------------------------
//--- take over an error message
//--------------------------------------------------------------------------

// calls ProcessMessage() with the message
void CErrorHandler::NoteError (char *message)
{
    ProcessMessage (message);
}


//--------------------------------------------------------------------------
//--- internal message output
//--------------------------------------------------------------------------

// print the message (followed by a newline) to cerr
void CErrorHandler::ProcessMessage (char *string)
{
    if (string != NULL) cerr << string << endl;
}



