//
// sim_glob.cpp
//
// definition of global object lists and initialization functions that are
// only needed in pure simulation
//
// note: for adding new network types, see the comments to function
//       InstallNetworks() below
//
// created: 12.10.96
//
// last change: 27.07.97
//
// RCS version control information:
//     $Revision: 1.1 $$State: Stable $$Date: 1998/06/16 10:49:31 $
//


#include "network.hpp"
#include "sim_glob.hpp"


//**************************************************************************
// global variables
//**************************************************************************

CNetworkManager networkManager;
// the network manager that returns the creation function of a certain
// network type



//**************************************************************************
// global object lists
//**************************************************************************

CClockList listOfClocks;
CLanceList listOfLances;
CNetworkList listOfNetworks;



//**************************************************************************
// initialization functions
//**************************************************************************

// installs all network types known in the system
// note: if you wish to add a new network type, you must insert its creation
// function into the network manager; just copy the two lines that are
// commented out below, and replace 'YourNetworkType' with the enumeration
// constant of your network (you must add one in enum ENetworkType in
// file general.hpp) and 'YourClassName' with the name of your network
// class (you must have derived one from class ACNetwork in file netbase.hpp)
void InstallNetworks()
{
    networkManager.SetFunction (Broadcast, CBroadcastNetwork::CreateNetwork);

//  networkManager.SetFunction (YourNetworkType, YourClassName::CreateNetwork);
}


