//
// structs.cpp
//
// all structures and classes that are needed to manage system parameters
// and events
//
// created: 31.01.97
//
// last change: 11.04.97
//
// RCS version control information:
//     $Revision: 1.2 $$State: Stable $$Date: 1998/07/03 12:45:47 $
//


#include <string.h>

#include "structs.hpp"


//--------------------------------------------------------------------------
//--- SEventReport (parameter for the event mask)
//--------------------------------------------------------------------------

SEventReport::SEventReport () { set = False; size = sizeof(*this); }

// set a single event
void SEventReport::Set (EEvent event, EBool on)
{
    set = on;
    type = EventReport;
/**/// the module is not needed, only the type; okay?
    value = event;  // set the event itself
    masksize = 0;  // no mask is stored
}

// set a single event class
void SEventReport::Set (EEventClass eventClass, EBool on)
{
    set = on;
    type = EventClassReport;
/**/// again, the module is not needed, only the type
    value = eventClass;  // set the event class itself
    masksize = 0;  // no mask is stored
}

// set a complete event (class) mask
void SEventReport::Set (ESystemParameter eventType, void *map, INT32 s)
{
    Assert ((eventType==EventReport) || (eventType==EventClassReport));
    Assert ((s > 0) && (s <= EventCount/8+1));
    Assert (map != NULL);

    type = eventType;
    memcpy (mask, map, s);  // copy the data
    masksize = s;  // store the size
}

// get the state of a single event (class)
void SEventReport::Get (EBool& on) const
{
    on = set;
}

// find out what value (event or event class) is stored in the base
// struct
void SEventReport::Get (SINT32& value) const
{
    value = (SINT32)SEventReport::value;
}


